--- 
- name: 更新 /etc/modprobe.d/cramfs.conf 文件
  hosts: all
  gather_facts: no
  tasks:
    - name: 檢查 /etc/modprobe.d/cramfs.conf 文件是否存在
      stat:
        path: /etc/modprobe.d/cramfs.conf
      register: cramfs_file

    - name: 抓取 /etc/modprobe.d/cramfs.conf 文件的内容
      shell: cat /etc/modprobe.d/cramfs.conf
      register: file_content
      ignore_errors: yes
      when: cramfs_file.stat.exists == true

    - name: 設置變數 content_matched
      set_fact:
        content_matched: "{{ file_content.stdout | regex_search('install cramfs /bin/true\\nblacklist cramfs', ignorecase=True) is not none }}"
      ignore_errors: yes
      when: cramfs_file.stat.exists == true
      
    - name: show content_matched
      debug: 
        var: content_matched
   
    - name: 驗證 /etc/modprobe.d/cramfs.conf 文件的内容
      blockinfile:
        path: /etc/modprobe.d/cramfs.conf
        create: yes 
        block: |
          install cramfs /bin/true
          blacklist cramfs
      when: cramfs_file.stat.exists == false or not content_matched
      ignore_errors: yes
      
    - name: 輸出結果
      debug:
        msg: "/etc/modprobe.d/cramfs.conf 文件已更新"
      when: cramfs_file.stat.exists == false or not content_matched

    - name: 輸出結果
      debug:
        msg: "/etc/modprobe.d/cramfs.conf 文件已存在且内容已符合"
      when: cramfs_file.stat.exists == true and content_matched

